diff -uwbBpr libfloat/softfloat/bits32/softfloat.c SoftFloat-2a/softfloat/bits32/softfloat.c
--- libfloat/softfloat/bits32/softfloat.c	Wed Sep 15 16:18:51 1999
+++ SoftFloat-2a/softfloat/bits32/softfloat.c	Mon Sep 20 11:46:53 1999
@@ -2,8 +2,8 @@
 /*
 ===============================================================================
 
-This C source file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+This C source file is part of the SoftFloat IEC/IEEE Floating-Point
+Arithmetic Package, Release 2a.
 
 Written by John R. Hauser.  This work was made possible in part by the
 International Computer Science Institute, located at Suite 600, 1947 Center
@@ -12,8 +12,8 @@ National Science Foundation under grant 
 of this code was written as part of a project to build a fixed-point vector
 processor in collaboration with the University of California at Berkeley,
 overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
-is available through the web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
-arithmetic/softfloat.html'.
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -23,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -142,7 +142,7 @@ and significand `zSig', and returns the 
 point value corresponding to the abstract input.  Ordinarily, the abstract
 value is simply rounded and packed into the single-precision format, with
 the inexact exception raised if the abstract input cannot be represented
-exactly.  If the abstract value is too large, however, the overflow and
+exactly.  However, if the abstract value is too large, the overflow and
 inexact exceptions are raised and an infinity or maximal finite value is
 returned.  If the abstract value is too small, the input value is rounded to
 a subnormal number, and the underflow and inexact exceptions are raised if
@@ -155,7 +155,7 @@ significand must be normalized or smalle
 and it must not require rounding.  In the usual case that `zSig' is
 normalized, `zExp' must be 1 less than the ``true'' floating-point exponent.
 The handling of underflow and overflow follows the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 roundAndPackFloat32( flag zSign, int16 zExp, bits32 zSig )
@@ -215,9 +215,9 @@ static float32 roundAndPackFloat32( flag
 Takes an abstract floating-point value having sign `zSign', exponent `zExp',
 and significand `zSig', and returns the proper single-precision floating-
 point value corresponding to the abstract input.  This routine is just like
-`roundAndPackFloat32' except that `zSig' does not have to be normalized in
-any way.  In all cases, `zExp' must be 1 less than the ``true'' floating-
-point exponent.
+`roundAndPackFloat32' except that `zSig' does not have to be normalized.
+Bit 31 of `zSig' must be zero, and `zExp' must be 1 less than the ``true''
+floating-point exponent.
 -------------------------------------------------------------------------------
 */
 static float32
@@ -353,8 +353,8 @@ and extended significand formed by the c
 and `zSig2', and returns the proper double-precision floating-point value
 corresponding to the abstract input.  Ordinarily, the abstract value is
 simply rounded and packed into the double-precision format, with the inexact
-exception raised if the abstract input cannot be represented exactly.  If
-the abstract value is too large, however, the overflow and inexact
+exception raised if the abstract input cannot be represented exactly.
+However, if the abstract value is too large, the overflow and inexact
 exceptions are raised and an infinity or maximal finite value is returned.
 If the abstract value is too small, the input value is rounded to a
 subnormal number, and the underflow and inexact exceptions are raised if the
@@ -365,7 +365,7 @@ significand is not normalized, `zExp' mu
 returned is a subnormal number, and it must not require rounding.  In the
 usual case that the input significand is normalized, `zExp' must be 1 less
 than the ``true'' floating-point exponent.  The handling of underflow and
-overflow follows the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+overflow follows the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64
@@ -446,10 +446,10 @@ static float64
 -------------------------------------------------------------------------------
 Takes an abstract floating-point value having sign `zSign', exponent `zExp',
 and significand formed by the concatenation of `zSig0' and `zSig1', and
-returns the proper double-precision floating-point value corresponding to
-the abstract input.  This routine is just like `roundAndPackFloat64' except
-that the input significand has fewer bits and does not have to be normalized
-in any way.  In all cases, `zExp' must be 1 less than the ``true'' floating-
+returns the proper double-precision floating-point value corresponding
+to the abstract input.  This routine is just like `roundAndPackFloat64'
+except that the input significand has fewer bits and does not have to be
+normalized.  In all cases, `zExp' must be 1 less than the ``true'' floating-
 point exponent.
 -------------------------------------------------------------------------------
 */
@@ -483,7 +483,7 @@ static float64
 -------------------------------------------------------------------------------
 Returns the result of converting the 32-bit two's complement integer `a' to
 the single-precision floating-point format.  The conversion is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 int32_to_float32( int32 a )
@@ -491,7 +491,7 @@ float32 int32_to_float32( int32 a )
     flag zSign;
 
     if ( a == 0 ) return 0;
-    if ( a == 0x80000000 ) return packFloat32( 1, 0x9E, 0 );
+    if ( a == (sbits32) 0x80000000 ) return packFloat32( 1, 0x9E, 0 );
     zSign = ( a < 0 );
     return normalizeRoundAndPackFloat32( zSign, 0x9C, zSign ? - a : a );
 
@@ -501,7 +501,7 @@ float32 int32_to_float32( int32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the 32-bit two's complement integer `a' to
 the double-precision floating-point format.  The conversion is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 int32_to_float64( int32 a )
@@ -530,7 +530,7 @@ float64 int32_to_float64( int32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
@@ -541,7 +541,7 @@ int32 float32_to_int32( float32 a )
 {
     flag aSign;
     int16 aExp, shiftCount;
-    bits32 aSig, zExtra;
+    bits32 aSig, aSigExtra;
     int32 z;
     int8 roundingMode;
 
@@ -551,41 +551,44 @@ int32 float32_to_int32( float32 a )
     shiftCount = aExp - 0x96;
     if ( 0 <= shiftCount ) {
         if ( 0x9E <= aExp ) {
-            if ( a == 0xCF000000 ) return 0x80000000;
+            if ( a != 0xCF000000 ) {
             float_raise( float_flag_invalid );
-            if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) return 0x7FFFFFFF;
-            return 0x80000000;
+                if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) {
+                    return 0x7FFFFFFF;
+                }
+            }
+            return (sbits32) 0x80000000;
         }
         z = ( aSig | 0x00800000 )<<shiftCount;
         if ( aSign ) z = - z;
     }
     else {
         if ( aExp < 0x7E ) {
-            zExtra = aExp | aSig;
+            aSigExtra = aExp | aSig;
             z = 0;
         }
         else {
             aSig |= 0x00800000;
-            zExtra = aSig<<( shiftCount & 31 );
+            aSigExtra = aSig<<( shiftCount & 31 );
             z = aSig>>( - shiftCount );
         }
-        if ( zExtra ) float_exception_flags |= float_flag_inexact;
+        if ( aSigExtra ) float_exception_flags |= float_flag_inexact;
         roundingMode = float_rounding_mode;
         if ( roundingMode == float_round_nearest_even ) {
-            if ( (sbits32) zExtra < 0 ) {
+            if ( (sbits32) aSigExtra < 0 ) {
                 ++z;
-                if ( (bits32) ( zExtra<<1 ) == 0 ) z &= ~1;
+                if ( (bits32) ( aSigExtra<<1 ) == 0 ) z &= ~1;
             }
             if ( aSign ) z = - z;
         }
         else {
-            zExtra = ( zExtra != 0 );
+            aSigExtra = ( aSigExtra != 0 );
             if ( aSign ) {
-                z += ( roundingMode == float_round_down ) & zExtra;
+                z += ( roundingMode == float_round_down ) & aSigExtra;
                 z = - z;
             }
             else {
-                z += ( roundingMode == float_round_up ) & zExtra;
+                z += ( roundingMode == float_round_up ) & aSigExtra;
             }
         }
     }
@@ -597,10 +600,10 @@ int32 float32_to_int32( float32 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
-Arithmetic, except that the conversion is always rounded toward zero.  If
-`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
-conversion overflows, the largest integer with the same sign as `a' is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
 returned.
 -------------------------------------------------------------------------------
 */
@@ -616,10 +619,11 @@ int32 float32_to_int32_round_to_zero( fl
     aSign = extractFloat32Sign( a );
     shiftCount = aExp - 0x9E;
     if ( 0 <= shiftCount ) {
-        if ( a == 0xCF000000 ) return 0x80000000;
+        if ( a != 0xCF000000 ) {
         float_raise( float_flag_invalid );
         if ( ! aSign || ( ( aExp == 0xFF ) && aSig ) ) return 0x7FFFFFFF;
-        return 0x80000000;
+        }
+        return (sbits32) 0x80000000;
     }
     else if ( aExp <= 0x7E ) {
         if ( aExp | aSig ) float_exception_flags |= float_flag_inexact;
@@ -630,7 +634,8 @@ int32 float32_to_int32_round_to_zero( fl
     if ( (bits32) ( aSig<<( shiftCount & 31 ) ) ) {
         float_exception_flags |= float_flag_inexact;
     }
-    return aSign ? - z : z;
+    if ( aSign ) z = - z;
+    return z;
 
 }
 
@@ -638,7 +643,7 @@ int32 float32_to_int32_round_to_zero( fl
 -------------------------------------------------------------------------------
 Returns the result of converting the single-precision floating-point value
 `a' to the double-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -667,10 +672,10 @@ float64 float32_to_float64( float32 a )
 
 /*
 -------------------------------------------------------------------------------
-Rounds the single-precision floating-point value `a' to an integer, and
-returns the result as a single-precision floating-point value.  The
+Rounds the single-precision floating-point value `a' to an integer,
+and returns the result as a single-precision floating-point value.  The
 operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_round_to_int( float32 a )
@@ -728,10 +733,10 @@ float32 float32_round_to_int( float32 a 
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the single-precision
-floating-point values `a' and `b'.  If `zSign' is true, the sum is negated
-before being returned.  `zSign' is ignored if the result is a NaN.  The
-addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+floating-point values `a' and `b'.  If `zSign' is 1, the sum is negated
+before being returned.  `zSign' is ignored if the result is a NaN.
+The addition is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 addFloat32Sigs( float32 a, float32 b, flag zSign )
@@ -800,10 +805,10 @@ static float32 addFloat32Sigs( float32 a
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the single-
-precision floating-point values `a' and `b'.  If `zSign' is true, the
+precision floating-point values `a' and `b'.  If `zSign' is 1, the
 difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float32 subFloat32Sigs( float32 a, float32 b, flag zSign )
@@ -877,7 +882,7 @@ static float32 subFloat32Sigs( float32 a
 -------------------------------------------------------------------------------
 Returns the result of adding the single-precision floating-point values `a'
 and `b'.  The operation is performed according to the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_add( float32 a, float32 b )
@@ -899,7 +904,7 @@ float32 float32_add( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the result of subtracting the single-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_sub( float32 a, float32 b )
@@ -921,7 +926,7 @@ float32 float32_sub( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the result of multiplying the single-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_mul( float32 a, float32 b )
@@ -979,17 +984,15 @@ float32 float32_mul( float32 a, float32 
 /*
 -------------------------------------------------------------------------------
 Returns the result of dividing the single-precision floating-point value `a'
-by the corresponding value `b'.  The operation is performed according to
-the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+by the corresponding value `b'.  The operation is performed according to the
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_div( float32 a, float32 b )
 {
     flag aSign, bSign, zSign;
     int16 aExp, bExp, zExp;
-    bits32 aSig, bSig, zSig;
-    bits32 rem0, rem1;
-    bits32 term0, term1;
+    bits32 aSig, bSig, zSig, rem0, rem1, term0, term1;
 
     aSig = extractFloat32Frac( a );
     aExp = extractFloat32Exp( a );
@@ -1051,15 +1054,14 @@ float32 float32_div( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the remainder of the single-precision floating-point value `a'
 with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_rem( float32 a, float32 b )
 {
     flag aSign, bSign, zSign;
     int16 aExp, bExp, expDiff;
-    bits32 aSig, bSig;
-    bits32 q, allZero, alternateASig;
+    bits32 aSig, bSig, q, allZero, alternateASig;
     sbits32 sigMean;
 
     aSig = extractFloat32Frac( a );
@@ -1137,16 +1139,14 @@ float32 float32_rem( float32 a, float32 
 -------------------------------------------------------------------------------
 Returns the square root of the single-precision floating-point value `a'.
 The operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float32 float32_sqrt( float32 a )
 {
     flag aSign;
     int16 aExp, zExp;
-    bits32 aSig, zSig;
-    bits32 rem0, rem1;
-    bits32 term0, term1;
+    bits32 aSig, zSig, rem0, rem1, term0, term1;
 
     aSig = extractFloat32Frac( a );
     aExp = extractFloat32Exp( a );
@@ -1171,7 +1171,8 @@ float32 float32_sqrt( float32 a )
     zSig = estimateSqrt32( aExp, aSig ) + 2;
     if ( ( zSig & 0x7F ) <= 5 ) {
         if ( zSig < 2 ) {
-            zSig = 0xFFFFFFFF;
+            zSig = 0x7FFFFFFF;
+            goto roundAndPack;
         }
         else {
             aSig >>= aExp & 1;
@@ -1187,15 +1188,16 @@ float32 float32_sqrt( float32 a )
         }
     }
     shift32RightJamming( zSig, 1, &zSig );
+ roundAndPack:
     return roundAndPackFloat32( 0, zExp, zSig );
 
 }
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the single-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_eq( float32 a, float32 b )
@@ -1215,9 +1217,9 @@ flag float32_eq( float32 a, float32 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is less than or
-equal to the corresponding value `b', and 0 otherwise.  The comparison is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+Returns 1 if the single-precision floating-point value `a' is less than
+or equal to the corresponding value `b', and 0 otherwise.  The comparison
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1242,7 +1244,7 @@ flag float32_le( float32 a, float32 b )
 -------------------------------------------------------------------------------
 Returns 1 if the single-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_lt( float32 a, float32 b )
@@ -1264,10 +1266,10 @@ flag float32_lt( float32 a, float32 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the single-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The invalid exception is raised
-if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the single-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The invalid exception is
+raised if either operand is a NaN.  Otherwise, the comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_eq_signaling( float32 a, float32 b )
@@ -1288,7 +1290,7 @@ flag float32_eq_signaling( float32 a, fl
 Returns 1 if the single-precision floating-point value `a' is less than or
 equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs do not
 cause an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_le_quiet( float32 a, float32 b )
@@ -1316,7 +1318,7 @@ flag float32_le_quiet( float32 a, float3
 Returns 1 if the single-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause an
 exception.  Otherwise, the comparison is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float32_lt_quiet( float32 a, float32 b )
@@ -1342,7 +1344,7 @@ flag float32_lt_quiet( float32 a, float3
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic---which means in particular that the conversion is rounded
 according to the current rounding mode.  If `a' is a NaN, the largest
 positive integer is returned.  Otherwise, if the conversion overflows, the
@@ -1353,7 +1355,7 @@ int32 float64_to_int32( float64 a )
 {
     flag aSign;
     int16 aExp, shiftCount;
-    bits32 aSig0, aSig1, absZ, zExtra;
+    bits32 aSig0, aSig1, absZ, aSigExtra;
     int32 z;
     int8 roundingMode;
 
@@ -1363,50 +1365,50 @@ int32 float64_to_int32( float64 a )
     aSign = extractFloat64Sign( a );
     shiftCount = aExp - 0x413;
     if ( 0 <= shiftCount ) {
-        if ( 11 < shiftCount ) {
+        if ( 0x41E < aExp ) {
             if ( ( aExp == 0x7FF ) && ( aSig0 | aSig1 ) ) aSign = 0;
-            absZ = 0xC0000000;
+            goto invalid;
         }
-        else {
             shortShift64Left(
-                 aSig0 | 0x00100000, aSig1, shiftCount, &absZ, &zExtra );
-            if ( 0xC0000000 < absZ ) absZ = 0xC0000000;
-        }
+            aSig0 | 0x00100000, aSig1, shiftCount, &absZ, &aSigExtra );
+        if ( 0x80000000 < absZ ) goto invalid;
     }
     else {
         aSig1 = ( aSig1 != 0 );
         if ( aExp < 0x3FE ) {
-            zExtra = aExp | aSig0 | aSig1;
+            aSigExtra = aExp | aSig0 | aSig1;
             absZ = 0;
         }
         else {
             aSig0 |= 0x00100000;
-            zExtra = ( aSig0<<( shiftCount & 31 ) ) | aSig1;
+            aSigExtra = ( aSig0<<( shiftCount & 31 ) ) | aSig1;
             absZ = aSig0>>( - shiftCount );
         }
     }
     roundingMode = float_rounding_mode;
     if ( roundingMode == float_round_nearest_even ) {
-        if ( (sbits32) zExtra < 0 ) {
+        if ( (sbits32) aSigExtra < 0 ) {
             ++absZ;
-            if ( (bits32) ( zExtra<<1 ) == 0 ) absZ &= ~1;
+            if ( (bits32) ( aSigExtra<<1 ) == 0 ) absZ &= ~1;
         }
         z = aSign ? - absZ : absZ;
     }
     else {
-        zExtra = ( zExtra != 0 );
+        aSigExtra = ( aSigExtra != 0 );
         if ( aSign ) {
-            z = - ( absZ + ( ( roundingMode == float_round_down ) & zExtra ) );
+            z = - (   absZ
+                    + ( ( roundingMode == float_round_down ) & aSigExtra ) );
         }
         else {
-            z = absZ + ( ( roundingMode == float_round_up ) & zExtra );
+            z = absZ + ( ( roundingMode == float_round_up ) & aSigExtra );
         }
     }
     if ( ( aSign ^ ( z < 0 ) ) && z ) {
+ invalid:
         float_raise( float_flag_invalid );
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+        return aSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
-    if ( zExtra ) float_exception_flags |= float_flag_inexact;
+    if ( aSigExtra ) float_exception_flags |= float_flag_inexact;
     return z;
 
 }
@@ -1415,10 +1417,10 @@ int32 float64_to_int32( float64 a )
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the 32-bit two's complement integer format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
-Arithmetic, except that the conversion is always rounded toward zero.  If
-`a' is a NaN, the largest positive integer is returned.  Otherwise, if the
-conversion overflows, the largest integer with the same sign as `a' is
+performed according to the IEC/IEEE Standard for Binary Floating-Point
+Arithmetic, except that the conversion is always rounded toward zero.
+If `a' is a NaN, the largest positive integer is returned.  Otherwise, if
+the conversion overflows, the largest integer with the same sign as `a' is
 returned.
 -------------------------------------------------------------------------------
 */
@@ -1426,9 +1428,8 @@ int32 float64_to_int32_round_to_zero( fl
 {
     flag aSign;
     int16 aExp, shiftCount;
-    bits32 aSig0, aSig1, absZ, zExtra;
+    bits32 aSig0, aSig1, absZ, aSigExtra;
     int32 z;
-    int8 roundingMode;
 
     aSig1 = extractFloat64Frac1( a );
     aSig0 = extractFloat64Frac0( a );
@@ -1436,32 +1437,31 @@ int32 float64_to_int32_round_to_zero( fl
     aSign = extractFloat64Sign( a );
     shiftCount = aExp - 0x413;
     if ( 0 <= shiftCount ) {
-        if ( 11 < shiftCount ) {
+        if ( 0x41E < aExp ) {
             if ( ( aExp == 0x7FF ) && ( aSig0 | aSig1 ) ) aSign = 0;
-            absZ = 0xC0000000;
+            goto invalid;
         }
-        else {
             shortShift64Left(
-                aSig0 | 0x00100000, aSig1, shiftCount, &absZ, &zExtra );
-        }
+            aSig0 | 0x00100000, aSig1, shiftCount, &absZ, &aSigExtra );
     }
     else {
-        if ( aExp < 0x3FE ) {
-            zExtra = aExp | aSig0 | aSig1;
-            absZ = 0;
+        if ( aExp < 0x3FF ) {
+            if ( aExp | aSig0 | aSig1 ) {
+                float_exception_flags |= float_flag_inexact;
+            }
+            return 0;
         }
-        else {
             aSig0 |= 0x00100000;
-            zExtra = ( aSig0<<( shiftCount & 31 ) ) | aSig1;
+        aSigExtra = ( aSig0<<( shiftCount & 31 ) ) | aSig1;
             absZ = aSig0>>( - shiftCount );
         }
-    }
     z = aSign ? - absZ : absZ;
     if ( ( aSign ^ ( z < 0 ) ) && z ) {
+ invalid:
         float_raise( float_flag_invalid );
-        return aSign ? 0x80000000 : 0x7FFFFFFF;
+        return aSign ? (sbits32) 0x80000000 : 0x7FFFFFFF;
     }
-    if ( zExtra ) float_exception_flags |= float_flag_inexact;
+    if ( aSigExtra ) float_exception_flags |= float_flag_inexact;
     return z;
 
 }
@@ -1470,7 +1470,7 @@ int32 float64_to_int32_round_to_zero( fl
 -------------------------------------------------------------------------------
 Returns the result of converting the double-precision floating-point value
 `a' to the single-precision floating-point format.  The conversion is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -1499,10 +1499,10 @@ float32 float64_to_float32( float64 a )
 
 /*
 -------------------------------------------------------------------------------
-Rounds the double-precision floating-point value `a' to an integer, and
-returns the result as a double-precision floating-point value.  The
+Rounds the double-precision floating-point value `a' to an integer,
+and returns the result as a double-precision floating-point value.  The
 operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_round_to_int( float64 a )
@@ -1602,10 +1602,10 @@ float64 float64_round_to_int( float64 a 
 /*
 -------------------------------------------------------------------------------
 Returns the result of adding the absolute values of the double-precision
-floating-point values `a' and `b'.  If `zSign' is true, the sum is negated
-before being returned.  `zSign' is ignored if the result is a NaN.  The
-addition is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+floating-point values `a' and `b'.  If `zSign' is 1, the sum is negated
+before being returned.  `zSign' is ignored if the result is a NaN.
+The addition is performed according to the IEC/IEEE Standard for Binary
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64 addFloat64Sigs( float64 a, float64 b, flag zSign )
